#!/usr/bin/env python
#
# ffdump.py - A script to read data dumps from a Mazda head unit
#
# Usage:
#   Set up your terminal: stty -F /dev/ttyS0 -icanon 19200 cs8
#   Then run this script: ./ffdump.py < /dev/ttyS0
#

from __future__ import with_statement
import sys, time


with sys.stdin as f:
    buffer = []
    while True:
        d = ord(f.read(1))
        if d == 0xff:
            ignore = (8 - len(buffer)*8 - ord(f.read(1))) % 8
            print "%f" % time.time(),
            print "".join([ "%02X" % i for i in buffer ]),
            print ignore
            buffer = []
        else:
            buffer.append(d)

        
